'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _nukeEnv = require('nuke-env');

var _nukeHelper = require('nuke-helper');

var _variable = require('./variable');

var _variable2 = _interopRequireDefault(_variable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function styleProvider() {
  var theme = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var Variables = (0, _variable2.default)(theme);
  var core = theme.Core;
  return {
    Badge: {
      wrap: {
        alignSelf: 'center',
        backgroundColor: Variables['normal-bg-color'],
        justifyContent: 'center',
        alignItems: 'center'
      },
      'auto-container': {
        flexDirection: 'row',
        overflow: 'hidden'
      },
      'auto-chindren': {
        paddingTop: Variables['auto-padding'],
        paddingRight: Variables['auto-padding']
      },
      'auto-dot': {
        position: 'absolute',
        right: 0,
        top: 0
      },
      span: {
        alignSelf: 'center'
      },
      'dot-span': {
        width: _nukeHelper.rem.caculateRemToPx(Variables['dot-size']),
        height: _nukeHelper.rem.caculateRemToPx(Variables['dot-size']),
        borderRadius: 999,
        textAlign: 'center'
      },
      'number-span': _extends({
        color: Variables['number-color'],
        height: _nukeHelper.rem.caculateRemToPx(Variables['number-size']),
        minWidth: _nukeHelper.rem.caculateRemToPx(Variables['number-size']),
        'line-height': Variables['number-size'] }, core.padding(0, Variables['number-padding']), {
        fontSize: Variables['number-size-text'],
        borderRadius: Variables['number-border-radius']
      }),

      'unread-span': {
        backgroundColor: Variables['unread-bg-color']
      },
      'standalone-span': {
        position: 'static'
      }
    }
  };
}

module.exports = styleProvider;