/** @jsx createElement */

/**
 * Copyright (c) 2015-present, Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * @providesModule
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _nukeThemeProvider = require('nuke-theme-provider');

var _nukeView = require('nuke-view');

var _nukeView2 = _interopRequireDefault(_nukeView);

var _nukeText = require('nuke-text');

var _nukeText2 = _interopRequireDefault(_nukeText);

var _nukeTouchable = require('nuke-touchable');

var _nukeTouchable2 = _interopRequireDefault(_nukeTouchable);

var _styles = require('../styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Badge = function (_Component) {
  _inherits(Badge, _Component);

  function Badge(props) {
    _classCallCheck(this, Badge);

    var _this = _possibleConstructorReturn(this, (Badge.__proto__ || Object.getPrototypeOf(Badge)).call(this, props));

    _this.onPress = _this.onPress.bind(_this);
    _this.renderInnerText = _this.renderInnerText.bind(_this);
    return _this;
  }

  _createClass(Badge, [{
    key: 'onPress',
    value: function onPress() {
      var onPress = this.props.onPress;

      onPress && onPress();
    }
  }, {
    key: 'renderInnerText',
    value: function renderInnerText(hidden, textStyle, sup) {
      var renderBadge = this.props.renderBadge;

      if (!renderBadge) {
        if (!hidden) {
          return (0, _rax.createElement)(
            _nukeText2.default,
            { style: textStyle },
            sup
          );
        }
        return null;
      }
      return renderBadge();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          max = _props.max,
          count = _props.count,
          type = _props.type,
          children = _props.children,
          always = _props.always,
          _props$style = _props.style,
          style = _props$style === undefined ? {} : _props$style,
          renderBadge = _props.renderBadge;

      var styles = this.props.themeStyle;
      var sup = count;
      var hidden = false;

      sup = Number(count);

      if (!isNaN(sup)) {
        sup = sup > max ? max + '+' : count;
        (sup === 0 || sup === '0') && !always && (hidden = true);
      } else {
        sup = count; // for string
      }
      var wrapStyle = Object.assign({}, styles.wrap, styles[type + '-span'], sup || always ? styles['number-span'] : styles['dot-span'], styles['standalone-span'], style);
      var TextAttrArr = ['color', 'fontSize', 'fontStyle', 'fontWeight', 'lineHeight'];
      var inheritStyle = {};
      TextAttrArr.forEach(function (item) {
        if (wrapStyle[item]) {
          inheritStyle[item] = wrapStyle[item];
        }
      });
      var textStyle = Object.assign({}, styles.span, sup || always ? null : styles['dot-span'], inheritStyle);
      if (!type || type !== 'auto') {
        return (0, _rax.createElement)(
          _nukeView2.default,
          { x: 'badge', style: wrapStyle },
          !hidden ? (0, _rax.createElement)(
            _nukeText2.default,
            { style: textStyle },
            sup
          ) : null
        );
      }
      var touchStyle = [styles['auto-dot']];
      if (!renderBadge) {
        touchStyle.unshift(wrapStyle);
      }
      return (0, _rax.createElement)(
        _nukeView2.default,
        { style: styles['auto-container'] },
        (0, _rax.createElement)(
          _nukeView2.default,
          { style: styles['auto-chindren'] },
          children
        ),
        (0, _rax.createElement)(
          _nukeTouchable2.default,
          { x: 'badge', style: touchStyle, onPress: this.onPress },
          this.renderInnerText(hidden, textStyle, sup)
        )
      );
    }
  }]);

  return Badge;
}(_rax.Component);

Badge.displayName = 'Badge';

Badge.propTypes = {
  max: _rax.PropTypes.number,
  count: _rax.PropTypes.oneOfType([_rax.PropTypes.number, _rax.PropTypes.string]),
  type: _rax.PropTypes.oneOf(['normal', 'unread']),
  children: _rax.PropTypes.any,
  always: _rax.PropTypes.bool,
  onPress: _rax.PropTypes.func,
  themeStyle: _rax.PropTypes.object,
  style: _rax.PropTypes.object,
  renderBadge: _rax.PropTypes.func
};

Badge.defaultProps = {
  max: 99,
  count: '',
  type: 'normal',
  children: null,
  always: false,
  onPress: function onPress() {},
  themeStyle: {},
  style: {},
  renderBadge: undefined
};

Badge.contextTypes = {
  getConfig: _rax.PropTypes.func
};

var StyledBadge = (0, _nukeThemeProvider.connectStyle)(_styles2.default)(Badge);

exports.default = StyledBadge;
module.exports = exports['default'];